Attribute VB_Name = "mdlDlgBox"

'==================='
'   mdlDlgBox.bas   '
' by ChiAlexus 2008 '
'==================='

Option Explicit

'=========================================================================================================================================================================================================='
'/ '

'      [/ ]'
Const OFN_OVERWRITEPROMPT = &H2         '         .
Const OFN_HIDEREADONLY = &H4            '     .
Const OFN_PATHMUSTEXIST = &H800         '      .
Const OFN_EXPLORER = &H80000            '    .

'C TOPENFILENAME'
Type TOPENFILENAME
     lStructSize As Long          '   
     hwndOwner As Long            ' ,  
     hInstance As Long            '    ,        .    ,    0
     lpstrFilter As String        '?
     lpstrCustomFilter As String  '?
     nMaxCustFilter As Long       '?
     nFilterIndex As Long         '?
     lpstrFile As String          '?
     nMaxFile As Long             '?
     lpstrFileTitle As String     '?
     nMaxFileTitle As Long        '?
     lpstrInitialDir As String    '?
     lpstrTitle As String         '?
     flags As Long                '?
     nFileOffset As Integer       '?
     nFileExtension As Integer    '?
     lpstrDefExt As String        '?
     lCustData As Long            '?
     lpfnHook As Long             '?
     lpTemplateName As String     '?
End Type

'   ()
Type tpFilePropperty
  tFileName As String      '   
  tFileTitle As String     ' 
End Type


' 
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As TOPENFILENAME) As Long
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As TOPENFILENAME) As Long
'=========================================================================================================================================================================================================='

'=========================================================================================================================================================================================================='
'  [ ]'

' 
Declare Function SHAbout Lib "Shell32" Alias "ShellAboutA" (ByVal hOwner As Long, ByVal sAppName As String, ByVal sPrompt As String, ByVal hIcon As Long) As Long
'=========================================================================================================================================================================================================='

Public vFileProp As tpFilePropperty
Public vOpenFileName As TOPENFILENAME

'  [/ ]
Public Sub InitOpenSaveDlg(shwndOwner As Form, slpstrFilter As String, slpstrFile As String, slpstrTitle As String)
  
  ' :
  'shwndOwner -  
  'slpstrFilter -  
  'slpstrFile -  
  'slpstrTitle -  
  
  Dim f As Integer
    
  With vOpenFileName
       .lStructSize = Len(vOpenFileName)
       .hwndOwner = shwndOwner.hWnd
       .flags = OFN_PATHMUSTEXIST Or OFN_OVERWRITEPROMPT Or OFN_HIDEREADONLY Or OFN_EXPLORER
       .lpstrFile = slpstrFile & String$(255 - Len(slpstrFile), 0)
       .nMaxFile = 255
       .lpstrFileTitle = String$(255, 0)
       .nMaxFileTitle = 255
       
       '  slpstrFilter
       For f = 1 To Len(slpstrFilter)
            If Mid(slpstrFilter, f, 1) = "|" Then
               Mid(slpstrFilter, f, 1) = vbNullChar
            End If
        Next f
        slpstrFilter = slpstrFilter & String$(2, 0)
        .lpstrFilter = slpstrFilter
        .nFilterIndex = 0
        If slpstrTitle <> "" Then .lpstrTitle = slpstrTitle
        .hInstance = App.hInstance
  End With

  Call DlgOpenFile

End Sub

'  [ ]
Private Sub DlgOpenFile()
  Dim vRetValue As Long
  vRetValue = GetOpenFileName(vOpenFileName)
  If vRetValue <> 0 Then
     vFileProp.tFileName = Left(vOpenFileName.lpstrFile, InStr(vOpenFileName.lpstrFile, vbNullChar) - 1)
     vFileProp.tFileTitle = Left(vOpenFileName.lpstrFileTitle, InStr(vOpenFileName.lpstrFileTitle, vbNullChar) - 1)
  End If
End Sub

'   About
Public Sub DlgAbout(shwndOwner As Form, sAppName As String, sPrompt As String)
    If sAppName = "" Then sAppName = Chr$(0)
    SHAbout shwndOwner.hWnd, sAppName, sPrompt, 0
End Sub

